<template>
	<section class="settings_main p-3">

		<div class="settings_content pr-3">
			<div class="settings_content_inr base_block">
				<div class="p-3">
					<div class="settings_panel">
						<div class="settings_panel_ttl">
							<div class="txt">{{$store.state.locale.localization}}</div>
							<button type="button" data-toggle="modal" data-target="#addLocalization" class="login_main_sign_btn bt" v-if="can('settings_localization', 'Edit')">
								{{$store.state.locale.addLocalization}}
							</button>
						</div>

						<div class="settings_panel_cnt">
							<div class="table-responsive settings_content_tb">
								<table class="table table-striped table-hover">
									<thead>
									<tr>
										<th scope="col">Key</th>
										<th scope="col">Tr-Uz</th>
										<th scope="col">Tr-Ru</th>
										<th scope="col">Tr-En</th>
										<th scope="col" class="w-40" v-if="can('settings_localization', 'Edit')"></th>
									</tr>
									</thead>
									<tbody>
									<tr v-for="loc in localizations">
										<td><input v-model="loc.field" type="text" class="form-control" :disabled="loc.id !== editId"></td>
										<td><input v-model="loc.valueUz" type="text" class="form-control" :disabled="loc.id !== editId"></td>
										<td><input v-model="loc.valueRu" type="text" class="form-control" :disabled="loc.id !== editId"></td>
										<td><input v-model="loc.valueEn" type="text" class="form-control" :disabled="loc.id !== editId"></td>
										<td v-if="can('settings_localization', 'Edit')">
											<div class="btn-group">
												<div v-if="loc.id === editId" style="width: 90px; display: inline-block;">
													<button @click="finishEditFunction(loc)" type="button" class="icon-btn">
														<i class="mdi mdi-check"></i>
													</button>
													<button @click="cancelEditFunction()" type="button" class="icon-btn">
														<i class="mdi mdi-close"></i>
													</button>
												</div>
												<div v-else style="width: 90px; display: inline-block;">
													<button @click="startEditFunc(loc)" type="button" class="icon-btn">
														<i class="mdi mdi-pencil"></i>
													</button>
												</div>
												<button v-if="loc.id !== editId" type="button" @click="deleteLoc(loc.id)" class="icon-btn">
													<i class="mdi mdi-delete"></i>
												</button>
											</div>
										</td>
									</tr>
									</tbody>
								</table>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>

		<div class="modal fade" id="addLocalization" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
			<div class="modal-dialog fn_ivr_modal" role="document">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title d-flex justify-content-center w-100">{{$store.state.locale.addLocalization}}</h5>
					</div>
					<div class="modal-body">
						<div>
							<label>Key</label>
							<input v-model="createLocalization.field" type="text" class="form-control">
						</div>
						<div>
							<label>Tr-Uz</label>
							<input v-model="createLocalization.valueUz" type="text" class="form-control">
						</div>
						<div>
							<label>Tr-Ru</label>
							<input v-model="createLocalization.valueRu" type="text" class="form-control">
						</div>
						<div>
							<label>Tr-En</label>
							<input v-model="createLocalization.valueEn" type="text" class="form-control">
						</div>
					</div>
					<div class="modal-footer">
						<div class="d-flex flex-wrap w-100 justify-content-between">
							<button type="button" @click="createLocalizationFunc()" class="fn_btn login_main_sign_btn mt-3 m-0">{{$store.state.locale.save}}</button>
							<button type="button" class="fn_btn btn_fn_danger mt-3 m-0" data-dismiss="modal">{{$store.state.locale.cancel}}</button>
						</div>
					</div>
				</div>
			</div>
		</div>

	</section>
</template>

<script>

export default {
	data() {
		return{
			localizations: [],
			createLocalization: {
				field: '',
				valueEn: '',
				valueRu: '',
				valueUz: ''
			},
			createFormLocalization: {
				field: '',
				valueEn: '',
				valueRu: '',
				valueUz: ''
			},
			editId: 0,
			editIndex: '',
			startEdit: {}
		}
	},
	created() {
		this.getStarted();
	},
	methods: {
		getStarted() {
			axios.get('/Localization/field')
				.then(res => {
					this.localizations = res.data.localizations
				})
		},
		deleteLoc(id) {
			if (confirm('Удалить?')) {
				axios.delete('/Localization/field/' + id)
					.then(res => {
						if (res.data.success === true) {
							this.localizations = this.localizations.filter(x => +x.id !== +id)
						}
					})
			}
		},
		createLocalizationFunc() {
			axios.post('/Localization/field', this.createLocalization)
				.then(res => {
					if (res.data.success === true) {
						this.createLocalization.id = res.data.result.id;
						this.localizations.push(this.createLocalization);
						this.createLocalization = {};
						$('#addLocalization').modal('hide');
					}
				})
		},
		startEditFunc(loc) {
			if (this.editId === 0) {
				this.editId = loc.id;
				this.startEdit = {...loc};
			} else {
				if (confirm('Если продолжите, последние изменения будут потеряны, продолжить?')) {
					this.localizations.forEach((obj, index) => {
						if (obj.id === this.editId) {
							this.editIndex = index
						}
					});
					this.localizations[this.editIndex] = {...this.startEdit};
					this.editId = 0;
					this.startEditFunc(loc);
				} else {
					return
				}
			}
		},
		finishEditFunction(loc) {
			axios.put('/Localization/field', loc)
				.then(res => {
					if (res.data.success === true) {
						this.editId = 0;
						this.editIndex = '';
						this.startEdit = {};
					}
				})
		},
		cancelEditFunction() {
			this.localizations.forEach((obj, index) => {
				if (obj.id === this.editId) {
					this.editIndex = index
				}
			});
			this.localizations[this.editIndex] = {...this.startEdit};
			this.editId = 0;
		},
	}
}
</script>

<style scoped>
.btn-group i{
	vertical-align: middle;
}
</style>